/*
* PLUGIN MANAGEMENT
* (c) by Sir D. 29.01.2007
*
* With this plugin, you can edit your files in plugin.ini.
* After editing/changing something, you need to make a mapchange to take effect.
*
* Needed:
* - file_access_read 1, file_access_write 1, amv_enable_beta "menu1", ACCESS_RCON
*
* ATTENTION:
* - PLEASE MAKE A COPY OF YOUR PLUGIN.INI, BEFORE YOU USE THIS PLUGIN!!!
*/

#include <string>
#include <admin>
#include <adminlib>

#define MAX_MENU_LENGTH	1500

new STRING_VERSION[MAX_DATA_LENGTH]="AM_2.50.60_b0.8";
new g_File[MAX_TEXT_LENGTH]="addons/adminmod/config/plugin.ini";
new g_ClientLogin;
new g_ClientKeyStart;
new g_ClientKeyEnd;
new g_change;

public plugin_init(){
	new Menu[MAX_NAME_LENGTH];
	new iFileAccessRead;
	new iFileAccessWrite;
	new error;
	
	//Check settings
	getstrvar("amv_enable_beta",Menu,MAX_NAME_LENGTH);
	iFileAccessRead=getvar("file_access_read");
	iFileAccessWrite=getvar("file_access_write");
	
	if(strstrx(Menu,"menu1")==-1){
		selfmessage("[PLUGIN MANAGEMENT] amv_enable_beta is not set to ^"menu1^" in adminmod.cfg! FATAL ERROR");
		error=1;
	}
	if(!iFileAccessRead){
		selfmessage("[PLUGIN MANAGEMENT] file_access_read is not set to ^"1^" in adminmod.cfg! FATAL ERROR");
		error=1;
	}
	if(!iFileAccessWrite){
		selfmessage("[PLUGIN MANAGEMENT] file_access_write is not set to ^"1^" in adminmod.cfg! FATAL ERROR");
		error=1;
	}
	if(!fileexists(g_File)){
		new Data[MAX_DATA_LENGTH];
		snprintf(Data,MAX_DATA_LENGTH,"[PLUGIN MANAGEMENT] File ^"%s^" not found! FATAL ERROR",g_File);
		selfmessage(Data);
		error=1;
	}
	if(!error){
		plugin_registerinfo("Plugin Management","Enable/Disable Plugins in game",STRING_VERSION);
		plugin_registercmd("admin_plugin","admin_plugin",ACCESS_RCON,"admin_plugin: shows menu of plugins, which can be enabled/disabled");
		plugin_registercmd("menuselect","menuselect",ACCESS_ALL);
		plugin_registercmd("radio1","SetMenuData",ACCESS_ALL);
		plugin_registercmd("radio2","SetMenuData",ACCESS_ALL);
		plugin_registercmd("radio3","SetMenuData",ACCESS_ALL);
		plugin_registercmd("buyequip","SetMenuData",ACCESS_ALL);
		plugin_registercmd("buy","SetMenuData",ACCESS_ALL);
		plugin_registercmd("chooseteam","SetMenuData",ACCESS_ALL);
		plugin_registercmd("showbriefing","SetMenuData",ACCESS_ALL);
	}else{
		plugin_registerinfo("Plugin Management","DISABLED! Important settings are missing! See log files!",STRING_VERSION);
		selfmessage("[Plugin Management] Plugin disabled! Important settings are missing! See log files!");
	}
	return PLUGIN_CONTINUE;
}

public admin_plugin(HLCommand,HLData,HLUserName,UserIndex){
	new UserName[MAX_NAME_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	if(!g_ClientLogin || g_ClientLogin==UserIndex){
		g_ClientLogin=UserIndex;
		g_ClientKeyStart=1;
		g_ClientKeyEnd=5;
		read_file(UserName,g_ClientKeyStart,g_ClientKeyEnd,1);
	}else{
		selfmessage("[Plugin Management] Sorry, someone else has control over plugin at the moment. Please try again later!");
	}
	return PLUGIN_HANDLED;
}

read_file(User[],iLineStart,iLineEnd,iMode){
	new Menu[MAX_MENU_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new iFileSize;
	new i;
	new keys=0;
	new key=1;
	new x;
	if(iMode){
		snprintf(Menu,MAX_MENU_LENGTH,"[PLUGINS]^n");
		iFileSize=filesize(g_File);
		if(iLineStart>iFileSize){
			iLineStart=1;
		}
		if(iLineEnd>iFileSize){
			iLineEnd=iFileSize;
		}
	}
	
	for(i=iLineStart;i<=iLineEnd;i++){
		if(iMode){
			x++;
			keys |= key;
		}
		readfile(g_File,Data,i,MAX_DATA_LENGTH);
		if(iMode){
			if(strncmp(Data,"//",2)!=0 && strncmp(Data,"#",1)!=0 && strncmp(Data,";",1)!=0 && strlen(Data)!=0){
				snprintf(Menu,MAX_MENU_LENGTH,"%s^n\w%i.%s",Menu,x,Data);
			}else{
				snprintf(Menu,MAX_MENU_LENGTH,"%s^n\w%i.\r%s",Menu,x,Data);
			}
			key <<= 1;
		}
	}
	
	if(iMode){
		snprintf(Menu,MAX_MENU_LENGTH,"%s^n",Menu);
		if(iFileSize>iLineEnd){
			snprintf(Menu,MAX_MENU_LENGTH,"%s^n\y8. Next",Menu);
			keys+=128;
		}
		if(iLineStart>5){
			snprintf(Menu,MAX_MENU_LENGTH,"%s^n\y9. Back",Menu);
			keys+=256;
		}
		snprintf(Menu,MAX_MENU_LENGTH,"%s^n^n\r0. Cancel",Menu);
		keys+=512;
		menu(User,Menu,keys);
	}else{
		if(strncmp(Data,"//",2)!=0 && strncmp(Data,"#",1)!=0 && strncmp(Data,";",1)!=0 && strlen(Data)!=0){
			snprintf(Data,MAX_DATA_LENGTH,"#%s",Data);
		}else{
			if(strncmp(Data,"//",2)==0){
				strsubst(Data, "//", "", MAX_DATA_LENGTH);
			}else if(strncmp(Data,"#",1)==0){
				strsubst(Data, "#", "", MAX_DATA_LENGTH);
			}else if(strncmp(Data,";",1)==0){
				strsubst(Data, ";", "", MAX_DATA_LENGTH);
			}
		}
		writefile(g_File,Data,iLineStart);
		read_file(User,g_ClientKeyStart,g_ClientKeyEnd,1);
	}
}

public menuselect(HLCommand,HLData,HLUserName,UserIndex){
	if(g_ClientLogin==UserIndex){
		new Data[MAX_DATA_LENGTH];
		new UserName[MAX_NAME_LENGTH];
		new iSelect;
		convert_string(HLData,Data,MAX_DATA_LENGTH);
		convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
		iSelect=strtonum(Data);
		if(iSelect==8){
			g_ClientKeyStart=g_ClientKeyStart+5;
			g_ClientKeyEnd=g_ClientKeyEnd+5;
			read_file(UserName,g_ClientKeyStart,g_ClientKeyEnd,1);
		}else if(iSelect==9){
			g_ClientKeyStart=g_ClientKeyStart-5;
			g_ClientKeyEnd=g_ClientKeyEnd-5;
			read_file(UserName,g_ClientKeyStart,g_ClientKeyEnd,1);
		}else if(iSelect==10){
			if(g_change){
				menu(UserName,"[PLUGIN-MANAGEMENT]^n^n\rMapchange needed, that changings take effect!!",1024);
			}
			exit_plugin();
		}else{
			g_change=1;
			read_file(UserName,g_ClientKeyStart+iSelect-1,g_ClientKeyStart+iSelect-1,0);
		}
		return PLUGIN_HANDLED;
	}
	return PLUGIN_CONTINUE;	
}
		
public plugin_disconnect(HLUserName,UserIndex) {
	if(1 <= UserIndex <= MAX_PLAYERS){
		if(g_ClientLogin==UserIndex){
			exit_plugin();
		}
	}
	return PLUGIN_CONTINUE;
}

public SetMenuData(HLCommand,HLData,HLUserName,UserIndex){
	new UserName[MAX_NAME_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	convert_string(HLUserName,UserName,MAX_NAME_LENGTH);
	if(g_ClientLogin==UserIndex){
		exit_plugin();
		snprintf(Text,MAX_TEXT_LENGTH,"[PLUGIN-MANAGEMENT] Menu is closed by another menu!");
		messageex(UserName,Text,print_chat);
	}
	return PLUGIN_CONTINUE;
}

exit_plugin(){
	g_ClientLogin=0;
	g_ClientKeyStart=0;
	g_ClientKeyEnd=0;
	g_change=0;
}